<?php

namespace patest\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPresalesRankWeightResponse ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfPresalesRankWeightResponse
 * @subpackage Arrays
 */
class ArrayOfPresalesRankWeightResponse extends AbstractStructArrayBase
{
    /**
     * The PresalesRankWeightResponse
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \patest\StructType\PresalesRankWeightResponse[]
     */
    public $PresalesRankWeightResponse;
    /**
     * Constructor method for ArrayOfPresalesRankWeightResponse
     * @uses ArrayOfPresalesRankWeightResponse::setPresalesRankWeightResponse()
     * @param \patest\StructType\PresalesRankWeightResponse[] $presalesRankWeightResponse
     */
    public function __construct(array $presalesRankWeightResponse = array())
    {
        $this
            ->setPresalesRankWeightResponse($presalesRankWeightResponse);
    }
    /**
     * Get PresalesRankWeightResponse value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \patest\StructType\PresalesRankWeightResponse[]|null
     */
    public function getPresalesRankWeightResponse()
    {
        return isset($this->PresalesRankWeightResponse) ? $this->PresalesRankWeightResponse : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPresalesRankWeightResponse method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPresalesRankWeightResponse method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePresalesRankWeightResponseForArrayConstraintsFromSetPresalesRankWeightResponse(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPresalesRankWeightResponsePresalesRankWeightResponseItem) {
            // validation for constraint: itemType
            if (!$arrayOfPresalesRankWeightResponsePresalesRankWeightResponseItem instanceof \patest\StructType\PresalesRankWeightResponse) {
                $invalidValues[] = is_object($arrayOfPresalesRankWeightResponsePresalesRankWeightResponseItem) ? get_class($arrayOfPresalesRankWeightResponsePresalesRankWeightResponseItem) : sprintf('%s(%s)', gettype($arrayOfPresalesRankWeightResponsePresalesRankWeightResponseItem), var_export($arrayOfPresalesRankWeightResponsePresalesRankWeightResponseItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PresalesRankWeightResponse property can only contain items of type \patest\StructType\PresalesRankWeightResponse, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PresalesRankWeightResponse value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \patest\StructType\PresalesRankWeightResponse[] $presalesRankWeightResponse
     * @return \patest\ArrayType\ArrayOfPresalesRankWeightResponse
     */
    public function setPresalesRankWeightResponse(array $presalesRankWeightResponse = array())
    {
        // validation for constraint: array
        if ('' !== ($presalesRankWeightResponseArrayErrorMessage = self::validatePresalesRankWeightResponseForArrayConstraintsFromSetPresalesRankWeightResponse($presalesRankWeightResponse))) {
            throw new \InvalidArgumentException($presalesRankWeightResponseArrayErrorMessage, __LINE__);
        }
        if (is_null($presalesRankWeightResponse) || (is_array($presalesRankWeightResponse) && empty($presalesRankWeightResponse))) {
            unset($this->PresalesRankWeightResponse);
        } else {
            $this->PresalesRankWeightResponse = $presalesRankWeightResponse;
        }
        return $this;
    }
    /**
     * Add item to PresalesRankWeightResponse value
     * @throws \InvalidArgumentException
     * @param \patest\StructType\PresalesRankWeightResponse $item
     * @return \patest\ArrayType\ArrayOfPresalesRankWeightResponse
     */
    public function addToPresalesRankWeightResponse(\patest\StructType\PresalesRankWeightResponse $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \patest\StructType\PresalesRankWeightResponse) {
            throw new \InvalidArgumentException(sprintf('The PresalesRankWeightResponse property can only contain items of type \patest\StructType\PresalesRankWeightResponse, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PresalesRankWeightResponse[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \patest\StructType\PresalesRankWeightResponse|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \patest\StructType\PresalesRankWeightResponse|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \patest\StructType\PresalesRankWeightResponse|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \patest\StructType\PresalesRankWeightResponse|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \patest\StructType\PresalesRankWeightResponse|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PresalesRankWeightResponse
     */
    public function getAttributeName()
    {
        return 'PresalesRankWeightResponse';
    }
}
